library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;

entity diviseur_freq is
    generic (
        n_fast : natural := 15;
        n_slow : natural := 24
        );
    port (
        I_clk  : in  std_logic;
        I_rst  : in  std_logic;
        O_FAST : out std_logic;
        O_SLOW : out std_logic
        );
end diviseur_freq;

architecture Behavioral of diviseur_freq is

    signal compt : unsigned (26 downto 0);

begin

    process (I_clk, I_rst)
    begin
        if I_rst = '1' then
            compt <= (others => '0');
        elsif rising_edge(I_clk) then
            compt <= compt + 1;
        end if;
    end process;

    O_FAST <= compt(n_fast);
    O_SLOW <= compt(n_slow);

end Behavioral;
